'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

var _tasks = require('./tasks');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  return (0, _create2.default)({
    game: function game(_game, gameState) {
      this.game = _game;
      this.gameState = gameState;
      return this;
    },
    memory: function memory(_memory, memoryState) {
      this.memory = _memory;
      this.memoryState = memoryState;
      return this;
    },
    policies: function policies(move) {
      var learn = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : move;
      var show = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : learn;

      this.movePolicy = move;
      this.learnPolicy = learn;
      this.playPolicy = show;
      return this;
    },
    train: function train(n, alpha, gamma) {
      var trainment = (0, _tasks.train)(alpha, gamma, this.game, this.gameState, this.memory, this.memoryState, this.movePolicy, this.learnPolicy);

      for (var i = 0; i < n; i += 1) {
        this.memoryState = trainment.next().value;
      }return this;
    },
    play: function play(cb) {
      cb((0, _tasks.play)(this.game, this.gameState, this.memory, this.memoryState, this.playPolicy));
      return this;
    }
  });
};