'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (alpha, gamma, game, transition, memory, memoryState, policy) {
  var gameState = transition.gameState,
      nextGameState = transition.nextGameState,
      reward = transition.reward,
      action = transition.action;

  var actions = game.actions(nextGameState);
  var rater = memory.rater(memoryState, nextGameState);
  var nextAction = policy(actions, rater);
  var updater = learning(gamma, reward, rater(nextAction))(alpha, 1);
  return memory.update(memoryState, gameState, action, updater);
};

var learning = function learning(gamma, reward, nextQ) {
  return function (alpha, trace) {
    return function (Q) {
      return Q + alpha * trace * (reward - Q + gamma * nextQ);
    };
  };
};