"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.rater = exports.init = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var key = function key(game, action) {
  return [game, action].toString();
};


var init = function init(initial) {
  return { initial: initial, values: {} };
};

var rater = function rater(_ref, game) {
  var initial = _ref.initial,
      values = _ref.values;
  return function (action) {
    var k = key(game, action);
    return k in values ? values[k] : initial;
  };
};

var update = function update( // eslint-disable-line arrow-parens
_ref2, game, action, updater) {
  var initial = _ref2.initial,
      values = _ref2.values;

  var k = key(game, action);
  var value = k in values ? values[k] : initial;
  return { initial: initial, values: (0, _extends4.default)({}, values, (0, _defineProperty3.default)({}, k, updater(value))) };
};

exports.init = init;
exports.rater = rater;
exports.update = update;