'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var random = function random(actions) {
  return actions[Math.floor(Math.random() * actions.length)];
};

var greedy = function greedy(actions, rate) {
  return actions.map(function (action) {
    return { action: action, rate: rate(action) };
  }).sort(function (ra1, ra2) {
    return ra1.rate - ra2.rate;
  }).pop().action;
};

var egreedy = function egreedy(epsilon) {
  return function (actions, rate) {
    return (Math.random() < epsilon ? random : greedy)(actions, rate);
  };
};

exports.random = random;
exports.greedy = greedy;
exports.egreedy = egreedy;