'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.train = exports.play = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _learn = require('./learn');

var _learn2 = _interopRequireDefault(_learn);

var _move = require('./move');

var _move2 = _interopRequireDefault(_move);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [play, train].map(_regenerator2.default.mark);

function play(game, initialGameState, memory, memoryState, policy) {
  var gameState, transition;
  return _regenerator2.default.wrap(function play$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          gameState = initialGameState;

        case 1:
          if (game.final(gameState)) {
            _context.next = 8;
            break;
          }

          transition = (0, _move2.default)(game, gameState, memory, memoryState, policy);

          gameState = transition.nextGameState;
          _context.next = 6;
          return transition;

        case 6:
          _context.next = 1;
          break;

        case 8:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
}

function train(alpha, gamma, game, initialGameState, memory, initialMemoryState, movePolicy, learnPolicy) {
  var memoryState, gameState, transition;
  return _regenerator2.default.wrap(function train$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          memoryState = initialMemoryState;

        case 1:
          gameState = initialGameState;

          while (!game.final(gameState)) {
            transition = (0, _move2.default)(game, gameState, memory, memoryState, movePolicy);


            memoryState = (0, _learn2.default)(alpha, gamma, game, transition, memory, memoryState, learnPolicy);

            gameState = transition.nextGameState;
          }_context2.next = 5;
          return memoryState;

        case 5:
          _context2.next = 1;
          break;

        case 7:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this);
}

exports.play = play;
exports.train = train;